package bmci.esign.backendend.repositories;

import bmci.esign.backendend.dto.response.DashboardChart;
import bmci.esign.backendend.models.Demande;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface DemandeRepository extends JpaRepository<Demande, Long>, JpaSpecificationExecutor<Demande> {
    List<Demande> findAllByUserId(Long id);

    @Query(value = "SELECT count(d.id) as count, d.statut as statut FROM Demande d WHERE d.user.email= :email GROUP BY d.statut")
    List<DashboardChart> loadSignaturesChart(@Param("email") String email);
}
